/*
 *  exo05.h
 *  moyenne et variance des réels
 */

/*
 * on fait un fichier .h parce que on ne definit pas le main
 * les fichier .h (headers) sont des fichiers de definition
 */

/*
 * test si le tableau contient des elements tous egaux
 * name: egaux
 * @tab:    tableau d'entiers
 * @taille: taille du tableau (donc @taille >= 0)
 * @return: 1 si oui, 0 sinon
 */
int egaux(int tab[], int taille) {
  if (taille <= 1) return 1;
  int i;
  for ( i = 1; i < taille; i++) {
    if (tab[i] != tab[0]) return 0;
  }
  return 1;
}

/*
 * test si le tableau contient des elements triés par ordre
 * name: trie
 * @tab:    tableau d'entiers
 * @taille: taille du tableau (donc @taille >= 0)
 * @return: 1 si oui, 0 sinon
 */
int tries(int tab[], int taille) {
  if (taille <= 1) return 1;
  int i;
  for ( i = 1; i < taille; i++) {
    if (tab[i] != tab[i-1]) return 0;
  }
  return 1;
}

