/*
 *  exo12.c
 *  Érathostène
 */

#include <stdio.h>
#include <math.h>

#define MAX 100000

int main() {
  unsigned short int e[MAX];  // pour les booléens c'est mieux
                              // (mais pas obligatoire) d'utiliser
                              // des unsigned shot int, pour occuper
                              // la moindre mémoir possible
  unsigned int i,j,n;
  printf("Bonjour !\n");
  printf("Svp, tapez un entier : ");
  scanf("%d", &n);
  const double rc = sqrt(n);
  // les valeurs e[0] et e[1] sont inutilsées, mais pour raisons
  // de lisibilité c'est mieux les laisser tomber
  for (i = 2; i < n; i++) e[i] = 1; //initialisation.
  printf("Voici la liste de premiers plus petits que %d :\n",n);
  for (i = 2; i < rc; i++) {
    if(e[i]) {
      printf("%d ",i);
      for(j = 2*i; j < n; j += i) { // cycle sur les multiples de i
        e[j] = 0; // on efface ici tout les multiples de i
      }
    }
  }
  // de ce point on ne doit plus effacer des entiers, mais il faut
  // les afficher
  for(; i < n; i++) { // le for reprende le i où le precedent est sorti
    if(e[i]) {
      printf("%d ",i);
    }
  }
  printf("\nAu revoir !\n");
}
