/*
 *  exo10.c
 *  operation sur caractères
 */

#include <stdio.h>

#define MAX 500

void exo10(char res[], char chaine[]) {
  unsigned int i , j;
  // i pour chaine, j pour res (qui n'aura pas le même index)
  j = 0;
  for(i = 0; chaine[i]; i++) {
    if ('A' <= chaine[i] && chaine[i] <= 'Z') { // on peut comparer 
                                                // les caractères
                                                // (en fait on en compare
                                                // les valeurs ascii)
      res[j++] = 'a' + chaine[i] - 'A'; // on peut sommer et subtraire
        // ici on somme à 'a' la distance entre chaine[i] et 'A', donc
        // sa place dans l'alphabet, et on obtient la version minuscule
        // du caractère
        // noter res[j++] : la valeur donnèe par l'expression j++ est
        // j avant l'incrément (donc 0 la première fois). L'expression
        // ++j a le même effet sur la valeur, mais comme expression
        // renvoie la valeur après l'incrément        
      continue; // commande pour terminer ce bloc du cycle, mais continuer
                // à cycler
    }
    if ('a' <= chaine[i] && chaine[i] <= 'z') {
      res[j++] = chaine[i];
    }
  }
  res[j] = '\0';  // clotûre de la chaîne (importante !)
}

int main() {
  char in[MAX], out[MAX];
  printf("Bonjour !\n");
  printf("Svp, tapez une chaîne : ");
  scanf("%s", in);  // pas de &, parce que c'est un tableau, donc
                    // c'est déjà un pointeur
                    // %s c'est la chaîne de format pour les chaînes
                    // attention, la lecture d'une chaîne termine
                    // au premier espace ou caractére de nouvelle
                    // ligne
  exo10(out,in);
  printf("Resultat : %s\nAu revoir !\n",out);
}
